Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.orm.hibernate3
Interface HibernateCallback

    public interface HibernateCallback

Callback interface for Hibernate code. To be used with `HibernateTemplate`'s execution methods, often as anonymous classes within a method implementation. A typical implementation will call `Session.load/find/update` to perform some operations on persistent objects. It can also perform direct JDBC operations via Hibernate's `Session.connection()`, operating on a JDBC Connection.

Note that Hibernate works on unmodified plain Java objects, performing dirty detection via copies made at load time. Returned objects can thus be used outside of an active Hibernate Session without any hassle, e.g. for display in a web GUI. Reassociating such instances with a new Session, e.g. for updates when coming back from the GUI, is straightforward, as the instance has kept its identity. You should care to reassociate them as early as possible though, to avoid having already loaded a version from the database in the same Session.

Since:
  1.2
Author:
  Juergen Hoeller
See Also:
  `HibernateTemplate`, `HibernateTransactionManager`

Method Summary
`Object` | `doInHibernate(Session session)` Gets called by `HibernateTemplate.execute` with an active Hibernate `Session`.

Method Detail

### doInHibernate

    Object doInHibernate(Session session)
                         throws HibernateException,
                                SQLException

  Gets called by `HibernateTemplate.execute` with an active Hibernate `Session`. Does not need to care about activating or closing the `Session`, or handling transactions.

  If called without a thread-bound Hibernate transaction (initiated by HibernateTransactionManager), the code will simply get executed on the underlying JDBC connection with its transactional semantics. If Hibernate is configured to use a JTA-aware DataSource, the JDBC connection and thus the callback code will be transactional if a JTA transaction is active.

  Allows for returning a result object created within the callback, i.e. a domain object or a collection of domain objects. A thrown custom RuntimeException is treated as an application exception: It gets propagated to the caller of the template.

  Parameters:
    `session` - active Hibernate session
  Returns:
    a result object, or `null` if none
  Throws:
    `HibernateException` - if thrown by the Hibernate API
    `SQLException` - if thrown by Hibernate-exposed JDBC API
  See Also:
    `HibernateTemplate.execute(org.springframework.orm.hibernate3.HibernateCallback)`, `HibernateTemplate.executeFind(org.springframework.orm.hibernate3.HibernateCallback)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2008 The Spring Framework.